//---------------------------------------------------------------------------------------------------------------------------------------------------
// <copyright file="FPSCLass.cs" company="DarkWynter Studios">
//     Copyright (C)2007 DarkWynter Studios.  All rights reserved.
// </copyright>
//---------------------------------------------------------------------------------------------------------------------------------------------------
// {Contact : darkwynter.com for licensing information
//---------------------------------------------------------------------------------------------------------------------------------------------------

namespace ElementalGame.GraphicUserInterface
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Diagnostics;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Audio;
    using Microsoft.Xna.Framework.Content;
    using Microsoft.Xna.Framework.Graphics;
    using Microsoft.Xna.Framework.Input;
    using Microsoft.Xna.Framework.Storage;
    using System.Xml;
    #endregion

    using DarkWynterEngine.Globals;


    public class FPSCounter
    {
        // Global Timers
        TimeSpan elapsedTime = TimeSpan.Zero;
        private FPS fpsScreen;
        int frameRate = 0;
        int frameCounter = 0;

        public FPSCounter()
        {
            // Init Frames Per Second Counter
            fpsScreen = new FPS();
        }

        public void Update()
        {
            elapsedTime += Statics.elementalGameTime.ElapsedGameTime;

            if (elapsedTime > TimeSpan.FromSeconds(1))
            {
                elapsedTime -= TimeSpan.FromSeconds(1);
                frameRate = frameCounter;
                frameCounter = 0;
            }
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            if (Statics.enableFPSDisplay)
            {
                spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
                frameCounter++;
                fpsScreen.SetFPS(frameRate);
                Statics.graphics.GraphicsDevice.Viewport = Statics.defaultViewport;
                fpsScreen.Draw(spriteBatch);
                spriteBatch.End();
            }
        }
    }
}
