//---------------------------------------------------------------------------------------------------------------------------------------------------
// <copyright file="PauseScreen.cs" company="DarkWynter Studios">
//     Copyright (C)2007 DarkWynter Studios.  All rights reserved.
// </copyright>
//---------------------------------------------------------------------------------------------------------------------------------------------------
// {Contact : darkwynter.com for licensing information
//---------------------------------------------------------------------------------------------------------------------------------------------------

namespace ElementalGame.GraphicUserInterface
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Audio;
    using Microsoft.Xna.Framework.Content;
    using Microsoft.Xna.Framework.Graphics;
    using Microsoft.Xna.Framework.Input;
    using Microsoft.Xna.Framework.Storage;
    #endregion

    using DarkWynterEngine.Globals;

    // The Loading... Screen
    public class LoadingScreen : GameScreen
    {
        private const int glyphPositionX = 537;
        private const int glyphPositionY = 242;
        private const int glyphSize = 64;
        private Texture2D glyphTexture;
        private float rotation = 0;

        // Constructor:
        public LoadingScreen()
        {
            //Instantiate the GameMenu
            menu = new GameMenu("", 0,0);

            SetBackground(Statics.content.Load<Texture2D>("_textures/Loading"));
            SetGlyph(Statics.content.Load<Texture2D>("GamePicture"));
        }

        public void SetGlyph(Texture2D glyph)
        {
            glyphTexture = glyph;
        }

        public new void Draw(SpriteBatch spriteBatch)
        {
            base.Draw(spriteBatch);
            /*
            spriteBatch.Draw(glyphTexture, new Rectangle(glyphPositionX * Statics.SystemSettings.GAME_WINDOW_WIDTH / 800,
                                                         glyphPositionY * Statics.SystemSettings.GAME_WINDOW_HEIGHT / 600,
                                                         glyphSize * Statics.SystemSettings.GAME_WINDOW_WIDTH / 800,
                                                         glyphSize * Statics.SystemSettings.GAME_WINDOW_HEIGHT / 600), null, Color.White, rotation,
                                                         new Vector2(glyphTexture.Width / 2, glyphTexture.Height / 2), SpriteEffects.None, 0);
             */
            //RotateGlyph();
        }

        private void RotateGlyph()
        {
            rotation += 0.2f;
            if (rotation > Math.PI * 2)
            {
                rotation = 0;
            }
        }
    }
}