//---------------------------------------------------------------------------------------------------------------------------------------------------
// <copyright file="TitleScreen.cs" company="DarkWynter Studios">
//     Copyright (C)2007 DarkWynter Studios.  All rights reserved.
// </copyright>
//---------------------------------------------------------------------------------------------------------------------------------------------------
// {Contact : darkwynter.com for licensing information
//---------------------------------------------------------------------------------------------------------------------------------------------------

namespace ElementalGame.GraphicUserInterface
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Audio;
    using Microsoft.Xna.Framework.Content;
    using Microsoft.Xna.Framework.Graphics;
    using Microsoft.Xna.Framework.Input;
    using Microsoft.Xna.Framework.Storage;
    #endregion

    using DarkWynterEngine.Controllers;
    using DarkWynterEngine.Globals;

    // Our Starting Title Screen
    public class TitleScreen : GameScreen
    {

        // Constructor:
        public TitleScreen()
        {
            //Instantiate the GameMenu
            // Title screen will only have the splash image

            menu = new GameMenu("", Statics.SystemSettings.GAME_WINDOW_WIDTH / 2, Statics.SystemSettings.GAME_WINDOW_HEIGHT / 2);

            // Game Screen Backgrounds
            // Check for widescreen and load appropriatly
            if ((Statics.SystemSettings.GAME_WINDOW_WIDTH) / Statics.SystemSettings.GAME_WINDOW_HEIGHT > 1.5)
            {
                // Load the textures for the game screens
                SetBackground(Statics.content.Load<Texture2D>("_textures/TitleScreen_wide"));
            }
            else
            {
                // Load the textures for the game screens
                SetBackground(Statics.content.Load<Texture2D>("_textures/TitleScreen"));
            }

        }

        public override void CheckMenuChoices(GameFlow gameFlow, Controller MenuController, MenuSystem menuSystem)
        {
            base.CheckMenuChoices(gameFlow, MenuController, menuSystem);

            return;

            //// TITLE SCREEN ------------------------------------
            //// Exit 
            //if (MenuController.menuInput.GetMenuBackPressed)
            //{
            //    Audio.MenuBack();           // Play a sound
            //    Statics.gameState = Enums.EngineState.CREDITS;                // Exit

            //    Statics.screenSaverTimer.Reset();
            //    Statics.screenSaverTimer.Start();
            //}
            //// Start
            //else if (MenuController.menuInput.GetMenuStartPressed)
            //{
            //    // Show controls
            //    Statics.gameState = Enums.EngineState.GAME_SETUP;

            //    Statics.screenSaverTimer.Reset();
            //    Statics.screenSaverTimer.Start();
            //}
            //MenuController.AnyButtonPressed();
        }

    }
}