

namespace ElementalGame.Networking
{



//Client Code
using System;
using System.Net.Sockets;
using System.IO ;
using System.ComponentModel ;


    public class Client
    {
        //Define the components...
        private TcpClient myclient;
        private NetworkStream networkStream;
        private StreamReader streamReader;
        private StreamWriter streamWriter;

        public void OpenConnection(string hostname, int port)
        {
            try
            {
                myclient = new TcpClient(hostname, port);
            }
            catch
            {
                Console.WriteLine("Failed to connect to server at " + hostname + ":" + port );
                return;
            }

            //get a Network stream from the server
            networkStream = myclient.GetStream();
            streamReader = new StreamReader(networkStream);
            streamWriter = new StreamWriter(networkStream);
        }
        public void Write(string message)
        {
            try
            {
                Console.WriteLine("Client Send:");
                streamWriter.WriteLine(message);
                streamWriter.Flush();
            }
            catch (Exception ee)
            {
                Console.WriteLine("Exception sending to Server:" + ee.ToString());
            }
        }
        public string Read()
        {
            string s;
            try
            {
                s = streamReader.ReadLine();
                
                Console.WriteLine("Client Read:");
                Console.WriteLine(s);                
                return s;
            }
            catch (Exception ee)
            {
                Console.WriteLine("Exception reading from Server:" + ee.ToString());
                return null;
            }
        }
        public void CloseConnection()
        {
            //close all streams...
            //streamReader.Close();
            //streamWriter.Close();
            //networkStream.Close();
        }
    }

}
